#include "StdAfx.h"
#include "Utils.h"
#include "DebugWindow.h"
#include "Algorytm.h"
#include <math.h>
#include "cvcam.h"   



namespace OpenCVProject {
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::ComponentModel;
	using namespace System::Drawing;
	using namespace System::Threading;
	using namespace System::IO;
	



	Algorytm::Algorytm(DebugWindow^ okno) 
		{
		m_okno = okno;
		m_running=false;
		time_red=-1;
		time_blue=-1;
		time=0;
		time_to_start=5;
		
		this->timer1 = (gcnew System::Windows::Forms::Timer());
		this->timer1->Interval = 1000;
		this->timer1->Enabled=false;
		this->timer1->Tick += gcnew System::EventHandler(this, &Algorytm::timer1_Tick);

		}
	
		Algorytm::~Algorytm()
		{
			stop();
		}	

	void Algorytm::start()
		{
			if(!m_running)
			{


			m_running = true;
			m_pause=false;
			m_pause2=false;
			m_thread = gcnew Thread(gcnew ThreadStart(this,&Algorytm::watek));
			//m_thread->Start();
			}
			else
			{
				m_pause=false;
			}
			this->timer1->Enabled=true;
		}
	void Algorytm::step()
		{
			if(!m_running) 
			{			
				m_running = true;
				m_thread = gcnew Thread(gcnew ThreadStart(this,&Algorytm::watek));
				m_thread->Start();
			}
			m_pause=true; 
			m_pause2=false;
			if ((time_red>=0)&&(time_blue>=0)) this->timer1->Enabled=true;
		
		}
	void Algorytm::stop()
		{
			if(m_running) m_running = false;
			if(m_capture!=NULL)
			{
				pin_ptr<CvCapture*> cap = &m_capture;
				cvReleaseCapture(cap);
			}
		}
	void Algorytm::reset()
	{
	time_red=-1;
	time_blue=-1;
	this->timer1->Enabled=false;
	time=0;
	time_to_start=5;
					}





	void Algorytm::watek()
			{

				double parm_red1;
				double parm_red2;
				int parm_red3;
				double parm_blue1;
				double parm_blue2;
				int parm_blue3;

				int parm1;
				int parm2;
				int parm3;
				int parm4;
				int parm5;

				double f_parm1;
				double f_parm2;
				double f_parm3;
				double f_parm4;
				double f_parm5;
				double f_parm6;

				bool enable_arbiter;


				int height;
				int width; 
				int i,j;

				double predkosc_red;
				double predkosc_blue=0;
				double max_red=0;
				double max_blue=0;
				double droga_red=0;
				double droga_blue=0;
				int zwrot_red=0;
				int zwrot_blue=0;
				int cel_red=0;
				int cel_blue=0;
				int zderz_cel_red=0;
				int zderz_cel_blue=0;
				int punkt_red=0;
				int punkt_blue=0;

				int blue_points=0;
				int red_points=0;

				double kat=0;
				int zderzenie=0;
				int zderz=0;
				int lock_cel_red=0;
				int lock_zderz_cel_blue=0;
				int lock_zderz_cel_red=0;
				int lock_cel_blue=0;
				double odleglosc_wzajemna=0;
				

					std::vector<CvPoint> ruch_red;
					std::vector<CvPoint> ruch_blue;


			
				
				IplImage* frame1 = cvQueryFrame(m_capture);
					
				IplImage* frame_red= cvCreateImage(cvGetSize(frame1), IPL_DEPTH_8U, 3);


				IplImage* frame_blue= cvCreateImage(cvGetSize(frame1), IPL_DEPTH_8U, 3);
				IplImage* frame3= cvCreateImage(cvGetSize(frame1), IPL_DEPTH_8U, 1);
			
				CvFont font;
				cvInitFont( &font, CV_FONT_HERSHEY_COMPLEX, 0.6, 0.6, 0.0, 1, 1 );

				 array<String^>^ text = gcnew array<String^>(16);
				 array<System::Drawing::Bitmap^>^ Obraz = gcnew array<System::Drawing::Bitmap^>(5);

				uchar* ptr_src;
				uchar* ptr_dest;
						
				CvMoments moments;
				CvPoint  center;
				CvPoint  center_red;
				CvPoint  center_blue;
				center.x=0;
				center.y=0;

				//pomocnicze punkty
				CvPoint jeden;
				jeden.x=0;
				jeden.y=0;
				CvPoint dwa;
				dwa.x=0;
				dwa.y=0;
				CvPoint trzy;
				trzy.x=0;
				trzy.y=0;
				CvPoint wektor_1;
				wektor_1.x=0;
				wektor_1.y=0;
				CvPoint wektor_2;
				wektor_2.x=0;
				wektor_2.y=0;
				CvPoint wektor_3;
				wektor_3.x=0;
				wektor_3.y=0;



				while (m_running)
				{

					parm_red1=m_okno->parametry_red->parm1;
					parm_red2=m_okno->parametry_red->parm2;
					parm_red3=m_okno->parametry_red->parm3;
					parm_blue1=m_okno->parametry_blue->parm1;
					parm_blue2=m_okno->parametry_blue->parm2;
					parm_blue3=m_okno->parametry_blue->parm3;

					parm1=m_okno->movement->parm1;
					parm2=m_okno->movement->parm2;
					parm3=m_okno->movement->parm3;
					parm4=m_okno->movement->parm4;
					parm5=m_okno->movement->parm5;

					f_parm1=m_okno->factor->parm1;
				    f_parm2=m_okno->factor->parm2;
				    f_parm3=m_okno->factor->parm3;
				    f_parm4=m_okno->factor->parm4;
				    f_parm5=m_okno->factor->parm5;
					f_parm6=m_okno->factor->parm6;

					enable_arbiter=m_okno->arbiter;

					
					

					IplImage* frame1 = cvQueryFrame(m_capture);
					if (frame1==nullptr) {stop(); return;}

					Obraz[0]=narzedzia.IplImageToBitmap(frame1); /////////////
					/*
					cvCvtColor(frame1,frame1,CV_RGB2HSV);
					cvCvtColor(frame1,frame3,CV_RGB2GRAY);
					cvThreshold( frame3, frame3, 110, 255, CV_THRESH_BINARY);
					cvFlip(frame3,frame3,0);
					Obraz[3]=narzedzia.IplImageToBitmap(frame3); /////////////
					
					*/
					
				
		
					cvSmooth(frame1, frame1, CV_GAUSSIAN, 7, 7, 1., 1.);

					height = frame1->height;
                    width  = frame1->width;
					/////////////////////////////////////////////////////////
					////////  ROZPOZNANIE KOLORW
					//////////////////////////////////////////////////////////
					for (j=0;j<height;j++)
					{
						for(i=0;i<width;i++)
						{
							
							ptr_src= &CV_IMAGE_ELEM(frame1 ,uchar,j,i*3);
							ptr_dest= &CV_IMAGE_ELEM(frame_red,uchar,j,i*3);
							
			
							double blue_point=(double)ptr_src[0];
							double green_point=(double)ptr_src[1];
							double red_point=(double)ptr_src[2];
/*
							double tmp_sum=(red_point+green_point+blue_point);
							if (tmp_sum==0) tmp_sum=0.000000000000001;

							double b=blue_point/tmp_sum;
							double g=green_point/tmp_sum;
							double r=red_point/tmp_sum;

							ptr_src[0]=(unsigned char)(255*b);
							ptr_src[1]=(unsigned char)(255*g);
							ptr_src[2]=(unsigned char)(255*r);
							

							blue_point =(double)ptr_src[0];
							green_point=(double)ptr_src[1];
							red_point  =(double)ptr_src[2];
*/
							double tmp1=red_point/(green_point+0.001);//zeby nie dzielil przez 0
							double tmp2=red_point/(blue_point+0.001);//zeby nie dzielil przez 0

							if ((tmp1>parm_red1)&&(tmp2>parm_red2)&&(red_point>parm_red3))
							{
							ptr_dest[0]=ptr_src[0];
							ptr_dest[1]=ptr_src[1];
							ptr_dest[2]=ptr_src[2];
							}
							else
							{
							ptr_dest[0]=0;
							ptr_dest[1]=0;
							ptr_dest[2]=0;
							}
							//////////////////
							ptr_dest= &CV_IMAGE_ELEM(frame_blue,uchar,j,i*3);
							tmp1=blue_point/(red_point+0.001); //zeby nie dzielil przez 0
							tmp2=blue_point/(green_point+0.001); //zeby nie dzielil przez 0

							if ((tmp1>parm_blue1)&&(tmp2>parm_blue2)&&(blue_point>parm_blue3))
							{
							ptr_dest[0]=ptr_src[0];
							ptr_dest[1]=ptr_src[1];
							ptr_dest[2]=ptr_src[2];
							}
							else
							{
							ptr_dest[0]=0;
							ptr_dest[1]=0;
							ptr_dest[2]=0;
							}
						}
					}



					//obrcenie obrazkw
					cvFlip(frame_red,frame_red,0);
					cvFlip(frame_blue,frame_blue,0);
					// zapis do bitmapy
					Obraz[1]=narzedzia.IplImageToBitmap(frame_red);  /////////////////
					Obraz[2]=narzedzia.IplImageToBitmap(frame_blue);  /////////////////

					if ((!m_pause)||(!m_pause2)){
						m_pause2=true;


//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
/////////////RED
//////////////////////////////////////////
					cvCvtColor(frame_red,frame3,CV_RGB2GRAY);
	
					// progowanie binarne
					cvThreshold( frame3, frame3, 1, 255, CV_THRESH_BINARY);

					/////////////////////////////////////////
					// otwarcie - zamknicie
					// otwarcie
					cvDilate(frame3, frame3, 0, 3);
					cvErode(frame3, frame3, 0, 3);
					//zamkniecie
					cvErode(frame3, frame3, 0, 1);
					cvDilate(frame3, frame3, 0, 1);
					////////////////////////////////////////
					////////// momenty
					cvMoments(frame3, &moments, 0);
				    // wyliczenie srodka
					center_red.x =(int)(moments.m10 / moments.m00);
					center_red.y =height-(int)(moments.m01 / moments.m00);
///////////////////////////////////////////////////////////////
//RED - WYZNACZANIE PARAMETRW  -1 to zerowanie
					if (((center_red.x>0)||(center_red.y>0))&&(time_red!=-1)) 
					{
						time_red++;

						ruch_red.push_back(cvPoint(center_red.x,center_red.y)); 
						///////////////////////////////////////
						// sciezka
						for(int i=0; i<(int)(ruch_red.size()-1) ; i++ ) 
						{
							dwa = ruch_red[i]; // poprzedni punkt
							trzy = ruch_red[i+1]; // aktualny punkt
							if (m_okno->show_paths)
							cvLine(frame1,dwa,trzy,cvScalar(0,0,255,0)); // rysuj linie
						}
					////////////////////////////////////////
					///// PARAMETRY
					//musi zrobic przynajmniej 2 ruchy (pierwszy to inicjujacy =0)					
					if ((int)ruch_red.size()>1) 
					{
					//## prdko
					predkosc_red=(double)sqrt((double)((trzy.x-dwa.x)*(trzy.x-dwa.x)+(trzy.y-dwa.y)*(trzy.y-dwa.y)));
					//## droga
					droga_red+=predkosc_red;
					//## max prdko
					if (max_red<predkosc_red) max_red=predkosc_red;
					}
					//## zwrotno
					// dopiero jak beda przynajmniej 3 punkty to liczy zwrotnosc (pierwszy to inicjujacy =0)	
					if ((int)ruch_red.size()>3)  
					{
						jeden=ruch_red[(int)ruch_red.size()-3];
						wektor_1.x = dwa.x-jeden.x;
						wektor_1.y = dwa.y-jeden.y;
						wektor_2.x = trzy.x-dwa.x;
						wektor_2.y = trzy.y-dwa.y;
						//jesli dlugosci wektorow beda >3 to dopiero uwzglednia zwrotnosc wczesniej uznaje to za bd (szum)
						if ((sqrt((double)(wektor_2.x*wektor_2.x+wektor_2.y*wektor_2.y))>parm1)&&(sqrt((double)(wektor_1.x*wektor_1.x+wektor_1.y*wektor_1.y))>parm1))
						{
							kat=(double)acos((double)(wektor_1.x*wektor_2.x+wektor_1.y*wektor_2.y)/(double)(sqrt((double)(wektor_1.x*wektor_1.x+wektor_1.y*wektor_1.y))*sqrt((double)(wektor_2.x*wektor_2.x+wektor_2.y*wektor_2.y))));
							kat=kat/time_red*180;
							int tmp1=((int)(180*kat/3.14159265358979323846));
							if ((tmp1>parm2)) zwrot_red+=tmp1;
						}
					} 

					int tmp1,tmp2,tmp3,tmp4;

					// przeskalowanie na cm
					tmp1=(int)((predkosc_red*77*25)/220);
					tmp2=(int)((droga_red*77)/220);
					tmp3=(int)((droga_red*77*25)/((double)time_red*220));
					tmp4=(int)((max_red*77*25)/220);

					red_points=(int)(f_parm3*(double)tmp2+f_parm4*(double)zwrot_red+f_parm1*(double)tmp3+f_parm2*(double)tmp4+f_parm5*(double)cel_red+f_parm6*(double)zderz_cel_red);

					text[0] =""+tmp1;
					text[2] =""+tmp2;
					text[4] =""+zwrot_red;
					text[6] =""+tmp3;
					text[8]=""+tmp4;
					text[10]=""+cel_red;
					text[12]=""+zderz_cel_red;
					text[14]=""+red_points;
					}
					else 
					{
						time_red=0;
						ruch_red.clear();
						predkosc_red=0;
						max_red=0;
						droga_red=0;
						zwrot_red=0;
						cel_red=0;
						zderz_cel_red=0;
						text[0]="--";
						text[2] ="--";
						text[4] ="--";
						text[6] ="--";
						text[8] ="--";
						text[10]="--";
						text[12]="--";
						text[14]="--";
					}

//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
/////////////BLUE
//////////////////////////////////////////
					cvCvtColor(frame_blue,frame3,CV_RGB2GRAY);
					/////////////////////////////////////////
					// progowanie binarne
					cvThreshold( frame3, frame3, 1, 255, CV_THRESH_BINARY);
					/////////////////////////////////////////
					// otwarcie - zamkniecie
					// otwarcie 
					cvDilate(frame3, frame3, 0, 3);
					cvErode(frame3, frame3, 0, 3);
					//zamkniecie
					cvErode(frame3, frame3, 0, 1);
					cvDilate(frame3, frame3, 0, 1);
					////////////////////////////////////////
					////////// momenty
					cvMoments(frame3, &moments, 0);
					//srodek masy
					center_blue.x =(int)(moments.m10 / moments.m00);
					center_blue.y =height-(int)(moments.m01 / moments.m00);

//////////////////////////////////////////////////
/////////BLUE - WYZNACZANIE PARAMETTROW
					if (((center_blue.x>0)||(center_blue.y>0))&&(time_blue!=-1))
					{
						time_blue++;

						ruch_blue.push_back(cvPoint(center_blue.x,center_blue.y)); 
						///////////////////////////////////////
						///// sciezka
						for(int i=0; i<(int)(ruch_blue.size()-1) ; i++ ) 
						{
							dwa = ruch_blue[i]; // poprzedni punkt
							trzy = ruch_blue[i+1]; // aktualny punkt
							if (m_okno->show_paths)
							cvLine(frame1,dwa,trzy,cvScalar(255,0,0,0)); // rysuj linie
						}
					////////////////////////////////////////
					///// zwrotnosc i inne parametry
					//musi zrobic przynajmniej 2 ruchy (pierwszy to inicjujacy =0)
					if ((int)ruch_blue.size()>1) 
					{
					//## prdko
					predkosc_blue=(double)sqrt((double)((trzy.x-dwa.x)*(trzy.x-dwa.x)+(trzy.y-dwa.y)*(trzy.y-dwa.y)));
					//## droga
					droga_blue+=predkosc_blue;
					//## max prdko
					if (max_blue<predkosc_blue) max_blue=predkosc_blue;
					}
					//## zwrotno
					// dopiero jak beda przynajmniej 3 punkty to liczy zwrotnosc (pierwszy to inicjujacy =0)
					if ((int)ruch_blue.size()>3) 
					{
						jeden=ruch_blue[(int)ruch_blue.size()-3];
						wektor_1.x = dwa.x-jeden.x;
						wektor_1.y = dwa.y-jeden.y;
						wektor_2.x = trzy.x-dwa.x;
						wektor_2.y = trzy.y-dwa.y;
						//jesli dlugosci wektorow beda >3 to dopiero uwzglednia zwrotnosc jak mniejsza to uznaje to za bd (szum)
						if ((sqrt((double)(wektor_2.x*wektor_2.x+wektor_2.y*wektor_2.y))>parm1)&&(sqrt((double)(wektor_1.x*wektor_1.x+wektor_1.y*wektor_1.y))>parm1))
						{
							kat=(double)acos((double)(wektor_1.x*wektor_2.x+wektor_1.y*wektor_2.y)/(double)(sqrt((double)(wektor_1.x*wektor_1.x+wektor_1.y*wektor_1.y))*sqrt((double)(wektor_2.x*wektor_2.x+wektor_2.y*wektor_2.y))));
							kat=kat/time_blue*180;
							int tmp1=((int)(180*kat/3.14159265358979323846));
							if ((tmp1>parm2)) zwrot_blue+=tmp1;
						}
					}


					int tmp1,tmp2,tmp3,tmp4;
					// przeskalowanie na cm
					tmp1=(int)((predkosc_blue*77*25)/220);
					tmp2=(int)((droga_blue*77)/220);
					tmp3=(int)((droga_blue*77*25)/((double)time_blue*220));
					tmp4=(int)((max_blue*77*25)/220);

					blue_points=(int)(f_parm3*(double)tmp2+f_parm4*(double)zwrot_blue+f_parm1*(double)tmp3+f_parm2*(double)tmp4+f_parm5*(double)cel_blue+f_parm6*(double)zderz_cel_blue);

					text[1] =""+tmp1;
					text[3] =""+tmp2;
					text[5] =""+zwrot_blue;
					text[7] =""+tmp3;
					text[9]=""+tmp4;
					text[11]=""+cel_blue;
					text[13]=""+zderz_cel_blue;
					text[15]=""+blue_points;
					}
					else
					{
						ruch_blue.clear();
						time_blue=0;
						predkosc_blue=0;
						max_blue=0;
						droga_blue=0;
						time_blue=0;
						zwrot_blue=0;
						cel_blue=0;
						zderz_cel_blue=0;
						text[1]="--";
						text[3] ="--";
						text[5] ="--";
						text[7] ="--";
						text[9] ="--";
						text[11] ="--";
						text[13] ="--";
						text[15] ="--";
						
					}
	
//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////
/////////////RING - DETEKCJA ZDERZENIA I ATAKW DLA OBYDWU ZAWODNIKW
//////////////////////////////////////////
					odleglosc_wzajemna=sqrt((double)((center_red.x-center_blue.x)*(center_red.x-center_blue.x)+(center_red.y-center_blue.y)*(center_red.y-center_blue.y)));

//## ataki czerwonego
					// musz byc conajmniej dwa punkty czerwonego  i mysi byc obecny niebieski przeciwnik
					if (((int)ruch_red.size()>1)&&((int)ruch_blue.size()>1)&&(predkosc_red>parm3))  
					{
						dwa = ruch_red[ruch_red.size()-2]; 
						trzy = ruch_red[ruch_red.size()-1]; 

						jeden=ruch_blue[ruch_blue.size()-2];
						wektor_1.x = jeden.x-dwa.x;
						wektor_1.y = jeden.y-dwa.y;
						wektor_2.x = trzy.x-dwa.x;
						wektor_2.y = trzy.y-dwa.y;

					        int _tmp1=(int)(180*(atan2((double)wektor_1.y,(double)wektor_1.x))/3.14159265358979323846);
							int _tmp2=(int)(180*(atan2((double)wektor_2.y,(double)wektor_2.x))/3.14159265358979323846);

							int tmp1=-_tmp1+_tmp2;
							if (tmp1>180) tmp1 = 360-tmp1;
							if (tmp1<-180) tmp1 = 360+tmp1;

							if (abs(tmp1)<parm4) 
							{
								if (!lock_cel_red) {cel_red++; lock_cel_red=1;} else lock_cel_red=0;
								if ((odleglosc_wzajemna<=44)&&(!lock_zderz_cel_red))
								{
									zderz_cel_red++;
									lock_zderz_cel_red=1;
								} else lock_zderz_cel_red=0;
							}
							
					} 

//## ataki niebieskiego
					// musz byc conajmniej dwa punkty czerwonego  i mysi byc obecny niebieski przeciwnik
					if (((int)ruch_blue.size()>1)&&((int)ruch_red.size()>1)&&(predkosc_blue>parm3))  
					{
						dwa = ruch_blue[ruch_blue.size()-2]; 
						trzy = ruch_blue[ruch_blue.size()-1]; 

						jeden=ruch_red[ruch_red.size()-2];
						wektor_1.x = jeden.x-dwa.x;
						wektor_1.y = jeden.y-dwa.y;
						wektor_2.x = trzy.x-dwa.x;
						wektor_2.y = trzy.y-dwa.y;

					        int _tmp1=(int)(180*(atan2((double)wektor_1.y,(double)wektor_1.x))/3.14159265358979323846);
							int _tmp2=(int)(180*(atan2((double)wektor_2.y,(double)wektor_2.x))/3.14159265358979323846);

							int tmp1=-_tmp1+_tmp2;
							if (tmp1>180) tmp1 = 360-tmp1;
							if (tmp1<-180) tmp1 = 360+tmp1;

							if (abs(tmp1)<parm4) 
							{
								if (!lock_cel_blue) { cel_blue++; lock_cel_blue=1; } else lock_cel_blue=0;
								if ((odleglosc_wzajemna<=44)&&(!lock_zderz_cel_blue))
								{
								    zderz_cel_blue++;
									lock_zderz_cel_blue=1;
								} else lock_zderz_cel_blue=0;
							}
							
					} 
//## oblicza wypchnicia za ring i przyznaje punkty
					center.x=width/2;
					center.y=height/2;
					int yuko_red=0;
					int yuko_blue=0;
					// musz byc obydwa leszcze
					if (((int)ruch_blue.size()>0)&&((int)ruch_red.size()>0))					  
					{
					double odl_red=(double)sqrt((double)((center_red.x-center.x)*(center_red.x-center.x)+(center_red.y-center.y)*(center_red.y-center.y)));
					double odl_blue=(double)sqrt((double)((center_blue.x-center.x)*(center_blue.x-center.x)+(center_blue.y-center.y)*(center_blue.y-center.y)));			
					if ((odl_red<100)&&(odl_blue>100)&&(enable_arbiter)) {punkt_red++; yuko_red=1;}
					if ((odl_red>100)&&(odl_blue<100)&&(enable_arbiter)) {punkt_blue++; yuko_blue=1;}
					if (((odl_red>100)||(odl_blue>100))&&(enable_arbiter)) m_pause=true; 
					} 
//## oblicza faul starty i przyznaje punkty - musz by oboje
					if (((int)ruch_blue.size()>0)&&((int)ruch_red.size()>0))
							{
					if ((predkosc_red>parm5)&&(predkosc_blue<parm5)&&(time_to_start>0)&&(enable_arbiter)) {punkt_blue++; m_pause=true; yuko_blue=1;}
					if ((predkosc_blue>parm5)&&(predkosc_red<parm5)&&(time_to_start>0)&&(enable_arbiter)) {punkt_red++; m_pause=true; yuko_red=1;} 
					}
//## koniec meczu
					if ((time>179)&&(enable_arbiter)) m_pause=true; 


//maluje ring do kalibracji i markery

					
					if (m_okno->show_dohyo)
					cvCircle(frame1,center, center.y-10, cvScalar(200,200,200), 4);
	
					
					if (m_okno->show_info)
					{
					CvPoint  napis;
					napis.x= center.x-40;
					napis.y= 220;
					if ((!yuko_red)&&(!yuko_blue)) // jesli nie ma punktu to maluj czas
					{
					if(time_to_start>0)
					cvPutText( frame1, (char*)System::Runtime::InteropServices::Marshal:: StringToHGlobalAnsi("<< "+(time_to_start)+" >>").ToPointer(), napis, &font, CV_RGB(200,200,200));
					else
					{
						int minuty=time/60;
						int sekundy=time%60;
						napis.x= center.x-15;
						cvPutText( frame1, (char*)System::Runtime::InteropServices::Marshal:: StringToHGlobalAnsi(""+(minuty)+":"+(sekundy)).ToPointer(), napis, &font, CV_RGB(200,200,200));
				
					}
			
						if (ruch_red.size()>0)
						{
						napis.x= center_red.x+20;
						napis.y= center_red.y+20;
						if (napis.x>300) napis.x=300;
						if (napis.y>220) napis.y=220;
						cvPutText( frame1, (char*)System::Runtime::InteropServices::Marshal:: StringToHGlobalAnsi(""+punkt_red).ToPointer(), napis, &font, CV_RGB(255,100,100));
						}
						if (ruch_blue.size()>0)
						{
						napis.x=center_blue.x+20;
						napis.y=center_blue.y+20;
						if (napis.x>300) napis.x=300;
						if (napis.y>220) napis.y=220;
						cvPutText( frame1, (char*)System::Runtime::InteropServices::Marshal:: StringToHGlobalAnsi(""+punkt_blue).ToPointer(), napis, &font, CV_RGB(100,100,255));
						}
					}
					else
						if (yuko_red) cvPutText( frame1,"YUKO", napis, &font, CV_RGB(255,100,100));
						if (yuko_blue) cvPutText( frame1,"YUKO", napis, &font, CV_RGB(100,100,255));
					}
				
					
					// jak zderzenie to na czerwono markery
					if (m_okno->show_markers){
					if ((odleglosc_wzajemna<=44)&&(ruch_red.size()>0)&&(ruch_blue.size()>0))
					{
						// kola na czerwono jesli jest zderzenie
						cvCircle(frame1, center_red, 20, cvScalar(0,0,255), 2);
						cvCircle(frame1, center_blue, 20, cvScalar(0,0,255), 2);
						
						
					}
					else
					{
						// kola na zielono jesli nie ma zderzenia
						if (ruch_red.size()>0) cvCircle(frame1, center_red, 20, cvScalar(0,255,0), 2);
						if (ruch_blue.size()>0) cvCircle(frame1, center_blue, 20, cvScalar(0,255,0), 2);
					}
					}// if (m_okno->show_markers)

					//przekazanie obrazow do eventa
					Obraz[3]=narzedzia.IplImageToBitmap(frame1);  /////////////////
		
				

					}
					// EVENTuj

					Wyslij(this,text,Obraz);
					m_thread->Sleep(40);

				}// while

					//zwolnij obrazki
					cvReleaseImage(&frame_red);
					cvReleaseImage(&frame_blue);
					cvReleaseImage(&frame3);
	
	}
	void Algorytm::timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
		if (time_to_start>0) time_to_start--; 
		else 
			//if (time<=179) 
			time++;
		 }

}//namespace