
#pragma once



#include "cv.h"
#include "highgui.h"
#include "SelectVideoSourceDialog.h"
#include "Utils.h"

#include "Algorytm.h"
#include "Parameters.h"
#include "Movement.h"
#include "Factor.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace OpenCVProject {
	
	

	public ref class DebugWindow : public System::Windows::Forms::Form
	{

	public:
		DebugWindow(void)
		{
		algorytm = gcnew Algorytm(this);
		parametry_red=gcnew Parameters(0,1.5,1.7,180);
		parametry_blue=gcnew Parameters(1,1.4,1.6,100);
		movement=gcnew Movement(3,10,5,20,3);
		factor=gcnew Factor(1,1,1,0.001,100,1000);
		
		algorytm->Wyslij += gcnew WyslijEventHandler(this, &DebugWindow::WyslijHandlerInvoke);
		 
		show_dohyo=false;
		show_paths=true;
		show_markers=true;
		show_info=true;

		game_status=4;
		
		InitializeComponent();
		}

	protected:
		~DebugWindow()
		{
			algorytm->stop();
			if (components)	delete components;
		}
	private:
		 Algorytm^ algorytm;
		 System::ComponentModel::ComponentResourceManager^   dw_resources;

	public:
		 Parameters^ parametry_red;
		 Parameters^ parametry_blue;
		 Movement^ movement;
		 Factor^ factor;
		 bool show_dohyo;
		 bool show_paths;
		 bool show_markers;
		 bool show_info;
		 int game_status;
		 bool arbiter;

	private: System::Windows::Forms::Button^  button_Start;
	private: System::Windows::Forms::Button^  button_Source;
	private: int inter;

	private: System::Windows::Forms::GroupBox^		groupBox_source;
	private: System::Windows::Forms::GroupBox^		groupBox_control;
	private: System::Windows::Forms::GroupBox^		groupBox_pierwszy;
	private: System::Windows::Forms::GroupBox^  groupBox_drugi;
	private: System::Windows::Forms::Button^  button_New;

	private: System::Windows::Forms::Button^		button_step;
	private: System::ComponentModel::IContainer^	components;
	public:  System::Windows::Forms::PictureBox^	pictureBox2;
	public:  System::Windows::Forms::PictureBox^		pictureBox3;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	public:  System::Windows::Forms::PictureBox^  pictureBox4;


	private: System::Windows::Forms::GroupBox^  groupBox3;
	private: System::Windows::Forms::GroupBox^  groupBox4;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label_red;
	private: System::Windows::Forms::Label^  label_red_speed;
	private: System::Windows::Forms::Label^  label_blue_speed;
	private: System::Windows::Forms::Label^  label_sr;
	private: System::Windows::Forms::Label^  label_sb;
	private: System::Windows::Forms::Button^  button_par_red;
	private: System::Windows::Forms::Button^  button_par_blue;
	private: System::Windows::Forms::GroupBox^  groupBox5;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label_blue_dis;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label_red_dis;
	private: System::Windows::Forms::Label^  label_red_kat;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label_blue_kat;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label_blue_mean;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label_red_mean;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::Label^  label_blue_max;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label_red_max;
	private: System::Windows::Forms::Timer^  timer1;
	private: System::Windows::Forms::Label^  label_blue_ataki;
	private: System::Windows::Forms::Label^  label23;
	private: System::Windows::Forms::Label^  label_blue_celne;
	private: System::Windows::Forms::Label^  label34;
	private: System::Windows::Forms::Label^  label_red_ataki;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  label_red_celne;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::GroupBox^  groupBox6;
	private: System::Windows::Forms::Button^  button_factors;
	private: System::Windows::Forms::Button^  button_movement;
	private: System::Windows::Forms::GroupBox^  groupBox7;
	private: System::Windows::Forms::CheckBox^  checkBox_zawodnicy;
	private: System::Windows::Forms::CheckBox^  checkBox_sciezki;
	private: System::Windows::Forms::CheckBox^  checkBox_ring;
	private: System::Windows::Forms::CheckBox^  checkBox_info;
private: System::Windows::Forms::CheckBox^  checkBox1;
private: System::Windows::Forms::Label^  label_blue_point;
private: System::Windows::Forms::Label^  label_red_point;
	public:  System::Windows::Forms::PictureBox^	pictureBox1;


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(DebugWindow::typeid));
			this->button_Start = (gcnew System::Windows::Forms::Button());
			this->button_Source = (gcnew System::Windows::Forms::Button());
			this->groupBox_source = (gcnew System::Windows::Forms::GroupBox());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->groupBox_pierwszy = (gcnew System::Windows::Forms::GroupBox());
			this->pictureBox2 = (gcnew System::Windows::Forms::PictureBox());
			this->button_New = (gcnew System::Windows::Forms::Button());
			this->button_step = (gcnew System::Windows::Forms::Button());
			this->groupBox_control = (gcnew System::Windows::Forms::GroupBox());
			this->checkBox1 = (gcnew System::Windows::Forms::CheckBox());
			this->groupBox_drugi = (gcnew System::Windows::Forms::GroupBox());
			this->pictureBox3 = (gcnew System::Windows::Forms::PictureBox());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->pictureBox4 = (gcnew System::Windows::Forms::PictureBox());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->label_blue_ataki = (gcnew System::Windows::Forms::Label());
			this->label23 = (gcnew System::Windows::Forms::Label());
			this->label_blue_celne = (gcnew System::Windows::Forms::Label());
			this->label34 = (gcnew System::Windows::Forms::Label());
			this->label_red_ataki = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->label_red_celne = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label_blue_max = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label_red_max = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label_blue_mean = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label_red_mean = (gcnew System::Windows::Forms::Label());
			this->label_blue_kat = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label_red_kat = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label_blue_dis = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label_red_dis = (gcnew System::Windows::Forms::Label());
			this->label_sr = (gcnew System::Windows::Forms::Label());
			this->label_sb = (gcnew System::Windows::Forms::Label());
			this->label_blue_speed = (gcnew System::Windows::Forms::Label());
			this->label_red_speed = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label_red = (gcnew System::Windows::Forms::Label());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			this->button_par_red = (gcnew System::Windows::Forms::Button());
			this->button_par_blue = (gcnew System::Windows::Forms::Button());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->groupBox6 = (gcnew System::Windows::Forms::GroupBox());
			this->button_factors = (gcnew System::Windows::Forms::Button());
			this->button_movement = (gcnew System::Windows::Forms::Button());
			this->groupBox7 = (gcnew System::Windows::Forms::GroupBox());
			this->checkBox_info = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_zawodnicy = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_sciezki = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_ring = (gcnew System::Windows::Forms::CheckBox());
			this->label_red_point = (gcnew System::Windows::Forms::Label());
			this->label_blue_point = (gcnew System::Windows::Forms::Label());
			this->groupBox_source->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->groupBox_pierwszy->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox2))->BeginInit();
			this->groupBox_control->SuspendLayout();
			this->groupBox_drugi->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox3))->BeginInit();
			this->groupBox1->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox4))->BeginInit();
			this->groupBox3->SuspendLayout();
			this->groupBox5->SuspendLayout();
			this->groupBox6->SuspendLayout();
			this->groupBox7->SuspendLayout();
			this->SuspendLayout();
			// 
			// button_Start
			// 
			this->button_Start->BackColor = System::Drawing::Color::Gainsboro;
			this->button_Start->Enabled = false;
			this->button_Start->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_Start->ForeColor = System::Drawing::Color::Black;
			this->button_Start->Location = System::Drawing::Point(20, 23);
			this->button_Start->Name = L"button_Start";
			this->button_Start->Size = System::Drawing::Size(127, 37);
			this->button_Start->TabIndex = 0;
			this->button_Start->Text = L"Start";
			this->button_Start->UseVisualStyleBackColor = false;
			this->button_Start->Click += gcnew System::EventHandler(this, &DebugWindow::buttonStart_Click);
			// 
			// button_Source
			// 
			this->button_Source->BackColor = System::Drawing::Color::Gainsboro;
			this->button_Source->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_Source->ForeColor = System::Drawing::Color::Black;
			this->button_Source->Location = System::Drawing::Point(20, 139);
			this->button_Source->Name = L"button_Source";
			this->button_Source->Size = System::Drawing::Size(127, 37);
			this->button_Source->TabIndex = 2;
			this->button_Source->Text = L"Select Video Source";
			this->button_Source->UseVisualStyleBackColor = false;
			this->button_Source->Click += gcnew System::EventHandler(this, &DebugWindow::buttonSource_Click);
			// 
			// groupBox_source
			// 
			this->groupBox_source->Controls->Add(this->pictureBox1);
			this->groupBox_source->Controls->Add(this->button_Source);
			this->groupBox_source->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox_source->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox_source->Location = System::Drawing::Point(12, 12);
			this->groupBox_source->Name = L"groupBox_source";
			this->groupBox_source->Size = System::Drawing::Size(167, 184);
			this->groupBox_source->TabIndex = 4;
			this->groupBox_source->TabStop = false;
			this->groupBox_source->Text = L"source";
			// 
			// pictureBox1
			// 
			this->pictureBox1->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pictureBox1.Image")));
			this->pictureBox1->Location = System::Drawing::Point(13, 19);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(144, 114);
			this->pictureBox1->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pictureBox1->TabIndex = 1;
			this->pictureBox1->TabStop = false;
			// 
			// groupBox_pierwszy
			// 
			this->groupBox_pierwszy->BackColor = System::Drawing::Color::LightCoral;
			this->groupBox_pierwszy->Controls->Add(this->pictureBox2);
			this->groupBox_pierwszy->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 1.5F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox_pierwszy->ForeColor = System::Drawing::Color::Black;
			this->groupBox_pierwszy->Location = System::Drawing::Point(16, 48);
			this->groupBox_pierwszy->Name = L"groupBox_pierwszy";
			this->groupBox_pierwszy->Size = System::Drawing::Size(169, 133);
			this->groupBox_pierwszy->TabIndex = 5;
			this->groupBox_pierwszy->TabStop = false;
			// 
			// pictureBox2
			// 
			this->pictureBox2->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pictureBox2->Location = System::Drawing::Point(6, 9);
			this->pictureBox2->Name = L"pictureBox2";
			this->pictureBox2->Size = System::Drawing::Size(156, 114);
			this->pictureBox2->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pictureBox2->TabIndex = 1;
			this->pictureBox2->TabStop = false;
			// 
			// button_New
			// 
			this->button_New->BackColor = System::Drawing::Color::Gainsboro;
			this->button_New->Enabled = false;
			this->button_New->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_New->ForeColor = System::Drawing::Color::Black;
			this->button_New->Location = System::Drawing::Point(20, 109);
			this->button_New->Name = L"button_New";
			this->button_New->Size = System::Drawing::Size(127, 34);
			this->button_New->TabIndex = 6;
			this->button_New->Text = L"NEW MATCH";
			this->button_New->UseVisualStyleBackColor = false;
			this->button_New->Click += gcnew System::EventHandler(this, &DebugWindow::button_stop_Click);
			// 
			// button_step
			// 
			this->button_step->BackColor = System::Drawing::Color::Gainsboro;
			this->button_step->Enabled = false;
			this->button_step->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_step->ForeColor = System::Drawing::Color::Black;
			this->button_step->Location = System::Drawing::Point(20, 66);
			this->button_step->Name = L"button_step";
			this->button_step->Size = System::Drawing::Size(127, 37);
			this->button_step->TabIndex = 7;
			this->button_step->Text = L"Step/Pause";
			this->button_step->UseVisualStyleBackColor = false;
			this->button_step->Click += gcnew System::EventHandler(this, &DebugWindow::button_step_Click);
			// 
			// groupBox_control
			// 
			this->groupBox_control->Controls->Add(this->checkBox1);
			this->groupBox_control->Controls->Add(this->button_Start);
			this->groupBox_control->Controls->Add(this->button_step);
			this->groupBox_control->Controls->Add(this->button_New);
			this->groupBox_control->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox_control->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox_control->Location = System::Drawing::Point(12, 202);
			this->groupBox_control->Name = L"groupBox_control";
			this->groupBox_control->Size = System::Drawing::Size(167, 207);
			this->groupBox_control->TabIndex = 8;
			this->groupBox_control->TabStop = false;
			this->groupBox_control->Text = L"control";
			// 
			// checkBox1
			// 
			this->checkBox1->AutoSize = true;
			this->checkBox1->Checked = true;
			this->checkBox1->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox1->Location = System::Drawing::Point(22, 162);
			this->checkBox1->Name = L"checkBox1";
			this->checkBox1->Size = System::Drawing::Size(129, 20);
			this->checkBox1->TabIndex = 8;
			this->checkBox1->Text = L"enable referee";
			this->checkBox1->UseVisualStyleBackColor = true;
			this->checkBox1->CheckedChanged += gcnew System::EventHandler(this, &DebugWindow::checkBox1_CheckedChanged);
			// 
			// groupBox_drugi
			// 
			this->groupBox_drugi->BackColor = System::Drawing::Color::SteelBlue;
			this->groupBox_drugi->Controls->Add(this->pictureBox3);
			this->groupBox_drugi->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 1.5F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox_drugi->ForeColor = System::Drawing::Color::Black;
			this->groupBox_drugi->Location = System::Drawing::Point(709, 48);
			this->groupBox_drugi->Name = L"groupBox_drugi";
			this->groupBox_drugi->Size = System::Drawing::Size(169, 133);
			this->groupBox_drugi->TabIndex = 9;
			this->groupBox_drugi->TabStop = false;
			// 
			// pictureBox3
			// 
			this->pictureBox3->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pictureBox3->Location = System::Drawing::Point(6, 9);
			this->pictureBox3->Name = L"pictureBox3";
			this->pictureBox3->Size = System::Drawing::Size(156, 114);
			this->pictureBox3->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pictureBox3->TabIndex = 1;
			this->pictureBox3->TabStop = false;
			// 
			// groupBox1
			// 
			this->groupBox1->BackColor = System::Drawing::Color::Silver;
			this->groupBox1->Controls->Add(this->pictureBox4);
			this->groupBox1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 1.5F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox1->ForeColor = System::Drawing::Color::Black;
			this->groupBox1->Location = System::Drawing::Point(200, 20);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(504, 389);
			this->groupBox1->TabIndex = 10;
			this->groupBox1->TabStop = false;
			// 
			// pictureBox4
			// 
			this->pictureBox4->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pictureBox4->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pictureBox4.Image")));
			this->pictureBox4->Location = System::Drawing::Point(10, 11);
			this->pictureBox4->Name = L"pictureBox4";
			this->pictureBox4->Size = System::Drawing::Size(480, 365);
			this->pictureBox4->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pictureBox4->TabIndex = 1;
			this->pictureBox4->TabStop = false;
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->label_blue_point);
			this->groupBox3->Controls->Add(this->label_red_point);
			this->groupBox3->Controls->Add(this->label_blue_ataki);
			this->groupBox3->Controls->Add(this->label23);
			this->groupBox3->Controls->Add(this->label_blue_celne);
			this->groupBox3->Controls->Add(this->label34);
			this->groupBox3->Controls->Add(this->label_red_ataki);
			this->groupBox3->Controls->Add(this->label13);
			this->groupBox3->Controls->Add(this->label_red_celne);
			this->groupBox3->Controls->Add(this->label11);
			this->groupBox3->Controls->Add(this->label10);
			this->groupBox3->Controls->Add(this->label_blue_max);
			this->groupBox3->Controls->Add(this->label8);
			this->groupBox3->Controls->Add(this->label_red_max);
			this->groupBox3->Controls->Add(this->label7);
			this->groupBox3->Controls->Add(this->label_blue_mean);
			this->groupBox3->Controls->Add(this->label5);
			this->groupBox3->Controls->Add(this->label_red_mean);
			this->groupBox3->Controls->Add(this->label_blue_kat);
			this->groupBox3->Controls->Add(this->label6);
			this->groupBox3->Controls->Add(this->label_red_kat);
			this->groupBox3->Controls->Add(this->label3);
			this->groupBox3->Controls->Add(this->label4);
			this->groupBox3->Controls->Add(this->label_blue_dis);
			this->groupBox3->Controls->Add(this->label2);
			this->groupBox3->Controls->Add(this->label_red_dis);
			this->groupBox3->Controls->Add(this->label_sr);
			this->groupBox3->Controls->Add(this->label_sb);
			this->groupBox3->Controls->Add(this->label_blue_speed);
			this->groupBox3->Controls->Add(this->label_red_speed);
			this->groupBox3->Controls->Add(this->label1);
			this->groupBox3->Controls->Add(this->label_red);
			this->groupBox3->Controls->Add(this->groupBox4);
			this->groupBox3->Controls->Add(this->groupBox_pierwszy);
			this->groupBox3->Controls->Add(this->groupBox_drugi);
			this->groupBox3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox3->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox3->Location = System::Drawing::Point(12, 425);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(895, 187);
			this->groupBox3->TabIndex = 12;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"meters";
			// 
			// label_blue_ataki
			// 
			this->label_blue_ataki->AutoSize = true;
			this->label_blue_ataki->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_ataki->Location = System::Drawing::Point(609, 129);
			this->label_blue_ataki->Name = L"label_blue_ataki";
			this->label_blue_ataki->Size = System::Drawing::Size(18, 16);
			this->label_blue_ataki->TabIndex = 40;
			this->label_blue_ataki->Text = L"--";
			// 
			// label23
			// 
			this->label23->AutoSize = true;
			this->label23->Location = System::Drawing::Point(532, 129);
			this->label23->Name = L"label23";
			this->label23->Size = System::Drawing::Size(58, 16);
			this->label23->TabIndex = 39;
			this->label23->Text = L"atacks:";
			// 
			// label_blue_celne
			// 
			this->label_blue_celne->AutoSize = true;
			this->label_blue_celne->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_celne->Location = System::Drawing::Point(609, 145);
			this->label_blue_celne->Name = L"label_blue_celne";
			this->label_blue_celne->Size = System::Drawing::Size(18, 16);
			this->label_blue_celne->TabIndex = 38;
			this->label_blue_celne->Text = L"--";
			// 
			// label34
			// 
			this->label34->AutoSize = true;
			this->label34->Location = System::Drawing::Point(468, 145);
			this->label34->Name = L"label34";
			this->label34->Size = System::Drawing::Size(122, 16);
			this->label34->TabIndex = 37;
			this->label34->Text = L"accurate atacks:";
			// 
			// label_red_ataki
			// 
			this->label_red_ataki->AutoSize = true;
			this->label_red_ataki->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_ataki->Location = System::Drawing::Point(344, 129);
			this->label_red_ataki->Name = L"label_red_ataki";
			this->label_red_ataki->Size = System::Drawing::Size(18, 16);
			this->label_red_ataki->TabIndex = 36;
			this->label_red_ataki->Text = L"--";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(266, 128);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(58, 16);
			this->label13->TabIndex = 35;
			this->label13->Text = L"atacks:";
			// 
			// label_red_celne
			// 
			this->label_red_celne->AutoSize = true;
			this->label_red_celne->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_celne->Location = System::Drawing::Point(344, 145);
			this->label_red_celne->Name = L"label_red_celne";
			this->label_red_celne->Size = System::Drawing::Size(18, 16);
			this->label_red_celne->TabIndex = 34;
			this->label_red_celne->Text = L"--";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(202, 144);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(122, 16);
			this->label11->TabIndex = 33;
			this->label11->Text = L"accurate atacks:";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(456, 80);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(135, 16);
			this->label10->TabIndex = 32;
			this->label10->Text = L"max speed [cm/s]:";
			// 
			// label_blue_max
			// 
			this->label_blue_max->AutoSize = true;
			this->label_blue_max->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_max->Location = System::Drawing::Point(609, 81);
			this->label_blue_max->Name = L"label_blue_max";
			this->label_blue_max->Size = System::Drawing::Size(18, 16);
			this->label_blue_max->TabIndex = 31;
			this->label_blue_max->Text = L"--";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(191, 81);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(135, 16);
			this->label8->TabIndex = 30;
			this->label8->Text = L"max speed [cm/s]:";
			// 
			// label_red_max
			// 
			this->label_red_max->AutoSize = true;
			this->label_red_max->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_max->Location = System::Drawing::Point(344, 82);
			this->label_red_max->Name = L"label_red_max";
			this->label_red_max->Size = System::Drawing::Size(18, 16);
			this->label_red_max->TabIndex = 29;
			this->label_red_max->Text = L"--";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(468, 65);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(123, 16);
			this->label7->TabIndex = 28;
			this->label7->Text = L"m. speed [cm/s]:";
			// 
			// label_blue_mean
			// 
			this->label_blue_mean->AutoSize = true;
			this->label_blue_mean->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_mean->Location = System::Drawing::Point(609, 65);
			this->label_blue_mean->Name = L"label_blue_mean";
			this->label_blue_mean->Size = System::Drawing::Size(18, 16);
			this->label_blue_mean->TabIndex = 27;
			this->label_blue_mean->Text = L"--";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(202, 65);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(123, 16);
			this->label5->TabIndex = 26;
			this->label5->Text = L"m. speed [cm/s]:";
			// 
			// label_red_mean
			// 
			this->label_red_mean->AutoSize = true;
			this->label_red_mean->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_mean->Location = System::Drawing::Point(344, 66);
			this->label_red_mean->Name = L"label_red_mean";
			this->label_red_mean->Size = System::Drawing::Size(18, 16);
			this->label_red_mean->TabIndex = 25;
			this->label_red_mean->Text = L"--";
			// 
			// label_blue_kat
			// 
			this->label_blue_kat->AutoSize = true;
			this->label_blue_kat->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_kat->Location = System::Drawing::Point(609, 113);
			this->label_blue_kat->Name = L"label_blue_kat";
			this->label_blue_kat->Size = System::Drawing::Size(18, 16);
			this->label_blue_kat->TabIndex = 24;
			this->label_blue_kat->Text = L"--";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(537, 112);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(54, 16);
			this->label6->TabIndex = 23;
			this->label6->Text = L"agility:";
			// 
			// label_red_kat
			// 
			this->label_red_kat->AutoSize = true;
			this->label_red_kat->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_kat->Location = System::Drawing::Point(344, 113);
			this->label_red_kat->Name = L"label_red_kat";
			this->label_red_kat->Size = System::Drawing::Size(18, 16);
			this->label_red_kat->TabIndex = 22;
			this->label_red_kat->Text = L"--";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(270, 112);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(54, 16);
			this->label3->TabIndex = 21;
			this->label3->Text = L"agility:";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(486, 96);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(105, 16);
			this->label4->TabIndex = 20;
			this->label4->Text = L"distance [cm]:";
			// 
			// label_blue_dis
			// 
			this->label_blue_dis->AutoSize = true;
			this->label_blue_dis->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_dis->Location = System::Drawing::Point(609, 96);
			this->label_blue_dis->Name = L"label_blue_dis";
			this->label_blue_dis->Size = System::Drawing::Size(18, 16);
			this->label_blue_dis->TabIndex = 19;
			this->label_blue_dis->Text = L"--";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(219, 97);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(105, 16);
			this->label2->TabIndex = 18;
			this->label2->Text = L"distance [cm]:";
			// 
			// label_red_dis
			// 
			this->label_red_dis->AutoSize = true;
			this->label_red_dis->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_dis->Location = System::Drawing::Point(344, 97);
			this->label_red_dis->Name = L"label_red_dis";
			this->label_red_dis->Size = System::Drawing::Size(18, 16);
			this->label_red_dis->TabIndex = 17;
			this->label_red_dis->Text = L"--";
			// 
			// label_sr
			// 
			this->label_sr->AutoSize = true;
			this->label_sr->Location = System::Drawing::Point(488, 48);
			this->label_sr->Name = L"label_sr";
			this->label_sr->Size = System::Drawing::Size(103, 16);
			this->label_sr->TabIndex = 16;
			this->label_sr->Text = L"speed [cm/s]:";
			// 
			// label_sb
			// 
			this->label_sb->AutoSize = true;
			this->label_sb->Location = System::Drawing::Point(221, 49);
			this->label_sb->Name = L"label_sb";
			this->label_sb->Size = System::Drawing::Size(103, 16);
			this->label_sb->TabIndex = 15;
			this->label_sb->Text = L"speed [cm/s]:";
			// 
			// label_blue_speed
			// 
			this->label_blue_speed->AutoSize = true;
			this->label_blue_speed->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_blue_speed->Location = System::Drawing::Point(609, 48);
			this->label_blue_speed->Name = L"label_blue_speed";
			this->label_blue_speed->Size = System::Drawing::Size(18, 16);
			this->label_blue_speed->TabIndex = 14;
			this->label_blue_speed->Text = L"--";
			// 
			// label_red_speed
			// 
			this->label_red_speed->AutoSize = true;
			this->label_red_speed->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold));
			this->label_red_speed->Location = System::Drawing::Point(344, 49);
			this->label_red_speed->Name = L"label_red_speed";
			this->label_red_speed->Size = System::Drawing::Size(18, 16);
			this->label_red_speed->TabIndex = 13;
			this->label_red_speed->Text = L"--";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 15.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label1->ForeColor = System::Drawing::Color::RoyalBlue;
			this->label1->Location = System::Drawing::Point(466, 18);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(183, 25);
			this->label1->TabIndex = 12;
			this->label1->Text = L"BLUE FIGHTER:";
			// 
			// label_red
			// 
			this->label_red->AutoSize = true;
			this->label_red->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 15.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_red->ForeColor = System::Drawing::Color::Coral;
			this->label_red->Location = System::Drawing::Point(17, 18);
			this->label_red->Name = L"label_red";
			this->label_red->Size = System::Drawing::Size(171, 25);
			this->label_red->TabIndex = 11;
			this->label_red->Text = L"RED FIGHTER:";
			// 
			// groupBox4
			// 
			this->groupBox4->Location = System::Drawing::Point(424, 8);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(12, 173);
			this->groupBox4->TabIndex = 10;
			this->groupBox4->TabStop = false;
			// 
			// button_par_red
			// 
			this->button_par_red->BackColor = System::Drawing::Color::Gainsboro;
			this->button_par_red->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_par_red->ForeColor = System::Drawing::Color::Black;
			this->button_par_red->Location = System::Drawing::Point(29, 21);
			this->button_par_red->Name = L"button_par_red";
			this->button_par_red->Size = System::Drawing::Size(127, 37);
			this->button_par_red->TabIndex = 13;
			this->button_par_red->Text = L"Red fighter";
			this->button_par_red->UseVisualStyleBackColor = false;
			this->button_par_red->Click += gcnew System::EventHandler(this, &DebugWindow::button_par_red_Click);
			// 
			// button_par_blue
			// 
			this->button_par_blue->BackColor = System::Drawing::Color::Gainsboro;
			this->button_par_blue->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_par_blue->ForeColor = System::Drawing::Color::Black;
			this->button_par_blue->Location = System::Drawing::Point(29, 64);
			this->button_par_blue->Name = L"button_par_blue";
			this->button_par_blue->Size = System::Drawing::Size(127, 37);
			this->button_par_blue->TabIndex = 14;
			this->button_par_blue->Text = L"Blue fighter";
			this->button_par_blue->UseVisualStyleBackColor = false;
			this->button_par_blue->Click += gcnew System::EventHandler(this, &DebugWindow::button_par_blue_Click);
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->button_par_blue);
			this->groupBox5->Controls->Add(this->button_par_red);
			this->groupBox5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox5->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox5->Location = System::Drawing::Point(722, 161);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(187, 114);
			this->groupBox5->TabIndex = 15;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"fighters parameters";
			// 
			// timer1
			// 
			this->timer1->Interval = 500;
			this->timer1->Tick += gcnew System::EventHandler(this, &DebugWindow::timer1_Tick);
			// 
			// groupBox6
			// 
			this->groupBox6->Controls->Add(this->button_factors);
			this->groupBox6->Controls->Add(this->button_movement);
			this->groupBox6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox6->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox6->Location = System::Drawing::Point(722, 286);
			this->groupBox6->Name = L"groupBox6";
			this->groupBox6->Size = System::Drawing::Size(187, 123);
			this->groupBox6->TabIndex = 16;
			this->groupBox6->TabStop = false;
			this->groupBox6->Text = L"referee parameters";
			// 
			// button_factors
			// 
			this->button_factors->BackColor = System::Drawing::Color::Gainsboro;
			this->button_factors->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_factors->ForeColor = System::Drawing::Color::Black;
			this->button_factors->Location = System::Drawing::Point(29, 69);
			this->button_factors->Name = L"button_factors";
			this->button_factors->Size = System::Drawing::Size(127, 37);
			this->button_factors->TabIndex = 14;
			this->button_factors->Text = L"Factors";
			this->button_factors->UseVisualStyleBackColor = false;
			this->button_factors->Click += gcnew System::EventHandler(this, &DebugWindow::button_factors_Click);
			// 
			// button_movement
			// 
			this->button_movement->BackColor = System::Drawing::Color::Gainsboro;
			this->button_movement->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_movement->ForeColor = System::Drawing::Color::Black;
			this->button_movement->Location = System::Drawing::Point(29, 26);
			this->button_movement->Name = L"button_movement";
			this->button_movement->Size = System::Drawing::Size(127, 37);
			this->button_movement->TabIndex = 13;
			this->button_movement->Text = L"Movement";
			this->button_movement->UseVisualStyleBackColor = false;
			this->button_movement->Click += gcnew System::EventHandler(this, &DebugWindow::button_movement_Click);
			// 
			// groupBox7
			// 
			this->groupBox7->Controls->Add(this->checkBox_info);
			this->groupBox7->Controls->Add(this->checkBox_zawodnicy);
			this->groupBox7->Controls->Add(this->checkBox_sciezki);
			this->groupBox7->Controls->Add(this->checkBox_ring);
			this->groupBox7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->groupBox7->ForeColor = System::Drawing::Color::Gainsboro;
			this->groupBox7->Location = System::Drawing::Point(722, 12);
			this->groupBox7->Name = L"groupBox7";
			this->groupBox7->Size = System::Drawing::Size(187, 134);
			this->groupBox7->TabIndex = 16;
			this->groupBox7->TabStop = false;
			this->groupBox7->Text = L"view options";
			// 
			// checkBox_info
			// 
			this->checkBox_info->AutoSize = true;
			this->checkBox_info->Checked = true;
			this->checkBox_info->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox_info->Location = System::Drawing::Point(30, 104);
			this->checkBox_info->Name = L"checkBox_info";
			this->checkBox_info->Size = System::Drawing::Size(91, 20);
			this->checkBox_info->TabIndex = 3;
			this->checkBox_info->Text = L"show info";
			this->checkBox_info->UseVisualStyleBackColor = true;
			this->checkBox_info->CheckedChanged += gcnew System::EventHandler(this, &DebugWindow::checkBox_info_CheckedChanged);
			// 
			// checkBox_zawodnicy
			// 
			this->checkBox_zawodnicy->AutoSize = true;
			this->checkBox_zawodnicy->Checked = true;
			this->checkBox_zawodnicy->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox_zawodnicy->Location = System::Drawing::Point(30, 78);
			this->checkBox_zawodnicy->Name = L"checkBox_zawodnicy";
			this->checkBox_zawodnicy->Size = System::Drawing::Size(122, 20);
			this->checkBox_zawodnicy->TabIndex = 2;
			this->checkBox_zawodnicy->Text = L"show markers";
			this->checkBox_zawodnicy->UseVisualStyleBackColor = true;
			this->checkBox_zawodnicy->CheckedChanged += gcnew System::EventHandler(this, &DebugWindow::checkBox_zawodnicy_CheckedChanged);
			// 
			// checkBox_sciezki
			// 
			this->checkBox_sciezki->AutoSize = true;
			this->checkBox_sciezki->Checked = true;
			this->checkBox_sciezki->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox_sciezki->Location = System::Drawing::Point(30, 52);
			this->checkBox_sciezki->Name = L"checkBox_sciezki";
			this->checkBox_sciezki->Size = System::Drawing::Size(104, 20);
			this->checkBox_sciezki->TabIndex = 1;
			this->checkBox_sciezki->Text = L"show paths";
			this->checkBox_sciezki->UseVisualStyleBackColor = true;
			this->checkBox_sciezki->CheckedChanged += gcnew System::EventHandler(this, &DebugWindow::checkBox_sciezki_CheckedChanged);
			// 
			// checkBox_ring
			// 
			this->checkBox_ring->AutoSize = true;
			this->checkBox_ring->Location = System::Drawing::Point(30, 26);
			this->checkBox_ring->Name = L"checkBox_ring";
			this->checkBox_ring->Size = System::Drawing::Size(109, 20);
			this->checkBox_ring->TabIndex = 0;
			this->checkBox_ring->Text = L"show dohyo";
			this->checkBox_ring->UseVisualStyleBackColor = true;
			this->checkBox_ring->CheckedChanged += gcnew System::EventHandler(this, &DebugWindow::checkBox_ring_CheckedChanged);
			// 
			// label_red_point
			// 
			this->label_red_point->AutoSize = true;
			this->label_red_point->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 15.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_red_point->ForeColor = System::Drawing::Color::Coral;
			this->label_red_point->Location = System::Drawing::Point(193, 18);
			this->label_red_point->Name = L"label_red_point";
			this->label_red_point->Size = System::Drawing::Size(25, 25);
			this->label_red_point->TabIndex = 41;
			this->label_red_point->Text = L"0";
			// 
			// label_blue_point
			// 
			this->label_blue_point->AutoSize = true;
			this->label_blue_point->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 15.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_blue_point->ForeColor = System::Drawing::Color::RoyalBlue;
			this->label_blue_point->Location = System::Drawing::Point(648, 18);
			this->label_blue_point->Name = L"label_blue_point";
			this->label_blue_point->Size = System::Drawing::Size(25, 25);
			this->label_blue_point->TabIndex = 42;
			this->label_blue_point->Text = L"0";
			// 
			// DebugWindow
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::DarkGray;
			this->ClientSize = System::Drawing::Size(921, 624);
			this->Controls->Add(this->groupBox7);
			this->Controls->Add(this->groupBox6);
			this->Controls->Add(this->groupBox5);
			this->Controls->Add(this->groupBox3);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->groupBox_control);
			this->Controls->Add(this->groupBox_source);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::Fixed3D;
			this->MaximizeBox = false;
			this->Name = L"DebugWindow";
			this->Text = L"..:: KoNaR - Fight analyzer ::..";
			this->Load += gcnew System::EventHandler(this, &DebugWindow::DebugWindow_Load);
			this->groupBox_source->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->groupBox_pierwszy->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox2))->EndInit();
			this->groupBox_control->ResumeLayout(false);
			this->groupBox_control->PerformLayout();
			this->groupBox_drugi->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox3))->EndInit();
			this->groupBox1->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox4))->EndInit();
			this->groupBox3->ResumeLayout(false);
			this->groupBox3->PerformLayout();
			this->groupBox5->ResumeLayout(false);
			this->groupBox6->ResumeLayout(false);
			this->groupBox7->ResumeLayout(false);
			this->groupBox7->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion



	private: System::Void buttonSource_Click(System::Object^  sender, System::EventArgs^  e)
			 {
			algorytm->stop();	
				 try{
					 SelectVideoSourceDialog^ dialog = gcnew SelectVideoSourceDialog();
					 if(dialog->ShowDialog() == System::Windows::Forms::DialogResult::OK)
						{
						algorytm->m_capture=dialog->m_capture;
						button_step->Enabled=true;
						button_Start->Enabled=true;
						button_New->Enabled=true;
						algorytm->step();
						}
				 }
				 catch(Exception^ e)
				 {
					 pictureBox4->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
					 pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
					 MessageBox::Show(e->Message,"Error");
				 }		
			}

	private: System::Void DebugWindow_Load(System::Object^  sender, System::EventArgs^  e) 
			 {
			  dw_resources = (gcnew System::ComponentModel::ComponentResourceManager(DebugWindow::typeid));
			  arbiter=true;
			  pictureBox4->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
			  pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
			 }

	private: System::Void buttonStart_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
			if(algorytm->m_capture==nullptr)
			 {
				 MessageBox::Show("You must select video source!","Error");
				 pictureBox4->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
				 pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(dw_resources->GetObject(L"pictureBox4.Image")));
			 }
			 else algorytm->start();

			timer1->Enabled=false;
			button_step->BackColor = System::Drawing::Color::Gainsboro;
			button_Start->BackColor = System::Drawing::Color::GreenYellow;
			button_New->BackColor = System::Drawing::Color::Gainsboro;
		     }

	private: System::Void button_stop_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			algorytm->reset();		
			algorytm->step();
	
			timer1->Enabled=false;
			button_step->BackColor = System::Drawing::Color::Gainsboro;
			button_Start->BackColor = System::Drawing::Color::Gainsboro;
		 }

	private: System::Void button_step_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			algorytm->step();
			timer1->Enabled=true;
			button_step->BackColor = System::Drawing::Color::Orange;
			button_Start->BackColor = System::Drawing::Color::Gainsboro;
			button_New->BackColor = System::Drawing::Color::Gainsboro;
		 }


	private: void WyslijHandlerInvoke(Object^ sender,array<String^>^ text,array<System::Drawing::Bitmap^>^ Obraz)
			 {
				 try{
					 array<Object^>^ args = gcnew array<Object^>(3);
					 args[0] = sender;
					 args[1] = text;
					 args[2] = Obraz;
					 this->Invoke(gcnew WyslijEventHandler(this, &DebugWindow::WyslijHandler), args);
				 }
				 catch(Exception^ ){}
			 }

	private: void WyslijHandler(Object^ sender,array<String^>^ text,array<System::Drawing::Bitmap^>^ Obraz)
			 {
				 label_red_speed->Text=text[0];
				 label_blue_speed->Text=text[1];

				 label_red_dis->Text=text[2];
				 label_blue_dis->Text=text[3];

				 label_red_kat->Text=text[4];
				 label_blue_kat->Text=text[5];

				 label_red_mean->Text=text[6];
				 label_blue_mean->Text=text[7];

				 label_red_max->Text=text[8];
				 label_blue_max->Text=text[9];

				 label_red_ataki->Text=text[10];
				 label_blue_ataki->Text=text[11];

				 label_red_celne->Text=text[12];
				 label_blue_celne->Text=text[13];

				 label_red_point->Text=text[14];
				 label_blue_point->Text=text[15];

				 pictureBox1->Image=Obraz[0];
				 pictureBox2->Image=Obraz[1];
				 pictureBox3->Image=Obraz[2];
				 pictureBox4->Image=Obraz[3];
				 //pictureBox5->Image=Obraz5;

			 }


private: System::Void button_par_red_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 parametry_red->Show();
		 }
private: System::Void button_par_blue_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 parametry_blue->Show();
		 }

		 
private: System::Void checkBox_ring_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			 show_dohyo=checkBox_ring->Checked;
		 }
private: System::Void checkBox_sciezki_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			 show_paths=checkBox_sciezki->Checked;
		 }
private: System::Void checkBox_zawodnicy_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			 show_markers=checkBox_zawodnicy->Checked;
		 }
private: System::Void checkBox_info_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			 show_info=checkBox_info->Checked;
		 }
private: System::Void button_movement_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 movement->Show();
		 }
private: System::Void button_factors_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 factor->Show();

		 }

private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
			
			 if (inter!=0)
			 {
				 inter=0;
				 button_step->BackColor = System::Drawing::Color::Gainsboro;
			 }
			 else
			 {
				 inter=1;
				 button_step->BackColor = System::Drawing::Color::Orange;
			 }
		 }

private: System::Void checkBox1_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			 arbiter=checkBox1->Checked;
		 }
};   // end class
}   // end spacename

